enchant_sys_events:
    type: world
    debug: false
    events:
        on item enchanted priority:-5:
            - define item     <context.item>
            - define cost     <context.cost>
            - define lore     <[item].lore.if_null[<list>]>
            - define enchants <context.enchants>
            # For each enchantment being applied...
            - foreach <context.enchants> key:enchantment as:level:
                # Skip non denizen enchnantments
                - foreach next if:<[enchantment].as_enchantment.key.starts_with[denizen].not>
                # Skip if the enchant was removed from the enchant map
                - foreach next if:<[enchants].contains[<[enchantment]>].not>
                # Add custom lore
                - define lore:->:<[enchantment].as_enchantment.full_name[<[level]>]>
                - definemap context:
                    entity: <context.entity>
                    location: <context.location>
                    inventory: <context.inventory>
                    button: <context.button>
                    enchants: <[enchants].exclude[<[enchantment]>]>
                    cost: <[cost]>
                    item: <[item]>
                    enchantment: <[enchantment]>
                    level: <[level]>
                    lore: <[lore]>
                - customevent id:table_enchant_item context:<[context]> save:save
                # Cancel if the custom event cancelled
                - determine cancelled if:<entry[save].was_cancelled>
                # Determinations should come in the form of a single map entry, as custom event only handles adding to a list of outputs
                - define determines <entry[save].determination_list.first.as_map.if_null[<map>]>
                # Redefine values with ones from determination, if any
                - define item        <[determines.item]>        if:<[determines.item].exists>
                - define lore        <[determines.lore]>        if:<[determines.lore].exists>
                - define cost        <[determines.cost]>        if:<[determines.cost].exists>
                - define level       <[determines.level]>       if:<[determines.level].exists>
                - define enchants    <[determines.enchants]>    if:<[determines.enchants].exists>
                - define enchantment <[determines.enchantment]> if:<[determines.enchantment].exists>
            - determine passively enchants:<[enchants]>
            - determine passively result:<[item].with[lore=<[lore]>]>
            - determine passively <[cost]>
        on player prepares anvil craft item priority:-5:
            - define repair_cost    <context.repair_cost>
            - define new_name       <context.new_name>
            - define contents       <context.inventory.slot[1|2]>
            - define enchanted_book <[contents].last>
            - define item           <[contents].first>
            - define lore           <[item].lore.if_null[<list>]>
            - define item_enchants  <[item].enchantment_map>
            - define book_enchants  <[enchanted_book].enchantment_map.filter_tag[<[filter_key].as_enchantment.key.starts_with[denizen]>].if_null[]>
            # Stop if recipe doesn't craft anything
            - stop if:<context.item.advanced_matches[air]>
            # Stop if recipe doesn't use an enchanted book
            - stop if:<[enchanted_book].advanced_matches[air]>
            # Stop if no denizen enchantments are present
            - stop if:<[book_enchants].is_empty>
            # For every enchantment on the book...
            - foreach <[book_enchants]> key:enchantment as:level:
                - define enchantment <[enchantment].as_enchantment>
                - if <[item_enchants].get[<[enchantment].name>].exists>:
                    - define item_level <[item_enchants].get[<[enchantment].name>]>
                    # Skip processing if enchantment already present on item is the same level as the one on the book
                    - foreach next if:<[item_level].is_more_than[<[level]>]>
                    # Increase the level of the enchant being applied by 1 if the item contains the enchant at that level
                    - define level:++ if:<[level].equals[<[item_level]>]>
                    # Clamp level to between min and max of enchantment
                    - define level <[level].min[<[enchantment].max_level>].max[<[enchantment].min_level>]>
                    # Remove existing lore entry for this enchantment
                    - define lore:<-:<reset><gray><[enchantment].full_name[<[item_level]>]>
                # Cancel if the enchantment can't enchant item
                - determine cancelled if:<[enchantment].can_enchant[<context.item>].not>
                # Cancel if the enchantment is not compatible with existing enchantments on item
                - determine cancelled if:<[item].enchantment_map.filter_tag[<[enchantment].is_compatible[<[filter_key]>]>].equals[<[item].enchantment_map>].not>
                # Add enchantment lore to list
                - define lore:->:<reset><gray><[enchantment].full_name[<[level]>]>
                - definemap context:
                    item: <[item]>
                    enchantment: <[enchantment]>
                    enchants: <[book_enchants].exclude[<[enchantment]>]>
                    level: <[level]>
                    lore: <[lore]>
                    repair_cost: <[repair_cost]>
                    new_name: <[new_name]>
                    inventory: <context.inventory>
                # Fire a custom event for enchanting the item through an anvil
                - customevent id:anvil_enchant_item context:<[context]> save:save
                # Cancel if the custom event cancelled
                - determine cancelled if:<entry[save].was_cancelled>
                # Determinations should come in the form of a single map entry, as custom event only handles adding to a list of outputs
                - define determines <entry[save].determination_list.first.as_map.if_null[<map>]>
                # Redefine values with ones from determination, if any
                - define item        <[determines.item]>        if:<[determines.item].exists>
                - define lore        <[determines.lore]>        if:<[determines.lore].exists>
                - define level       <[determines.level]>       if:<[determines.level].exists>
                - define new_name    <[determines.new_name]>    if:<[determines.new_name].exists>
                - define repair_cost <[determines.repair_cost]> if:<[determines.repair_cost].exists>
                - define enchantment <[determines.enchantment]> if:<[determines.enchantment].exists>
                # Add enchantment to enchantment map
                - define item_enchants.<[enchantment].name>:<[level]>
            # Add lore and enchantment map to item
            - determine passively <[item].with[display=<[new_name]>;lore=<[lore]>;enchantments=<[item_enchants]>]>
            - determine passively <[repair_cost]>
